#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <string.h>
#define BUFLEN 200

int main(int argc, char *argv[]) 
{ 
    int sock; 
    int i, nread,nsent, match; 
    struct sockaddr_in dest_addr; 
    char buffer; 
    
    if(argc <2){
	printf("Echo Client\nUsage: %s <echo_server_ip> <echo_port> <message> \n",argv[0]);
        return 1;
	}

    /* create socket */ 
    if ( (sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) { 
        perror("Socket creation error"); 
        return 1; 
    } 
    /* initialize address */ 
    memset((void *) &dest_addr, 0, sizeof(dest_addr));    /* clear server address */ 
    dest_addr.sin_family = AF_INET;                       /* address type is INET */ 
    dest_addr.sin_port = htons(atoi(argv[2]));       
    /* build address using inet_pton */ 
    if ( (inet_pton(AF_INET, argv[1], &dest_addr.sin_addr)) <= 0) { 
        perror("Address creation error"); 
        return -1; 
    } 

    /* try to connect */

    if ( connect(sock,(struct sockaddr*) &dest_addr, sizeof(dest_addr)) < 0){
         perror("Error connecting to server : ");
         return 1;
    }

    /* send message */ 
    nsent = send(sock, argv[3], strlen(argv[3]),0);

    match = 1;
   /* receive echo back and check correctness */
    for ( nread=0; nread<nsent; nread ++){
    if ( recv(sock, &buffer, 1, 0) < 0) { 
        perror("Read error"); 
        return 1; 
     }
     match = match && (buffer == argv[3][nread]);
    }
    
    if (match){
        puts("Received correct echo back!\n");
    }
    /* normal exit */ 
    return 0; 
} 
