#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <string.h>
#define BUFLEN 200

int main(int argc, char *argv[]) 
{ 
    int sock; 
    int i, nread; 
    struct sockaddr_in dest_addr; 
    char buffer[BUFLEN]; 
    
    if(argc <1){
	printf("Daytime Client\nUsage: %s <daytime_server_ip>\n",argv[0]);
	}

    /* create socket */ 
    if ( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) { 
        perror("Socket creation error"); 
        return -1; 
    } 
    /* initialize address */ 
    memset((void *) &dest_addr, 0, sizeof(dest_addr));    /* clear server address */ 
    dest_addr.sin_family = AF_INET;                  /* address type is INET */ 
    dest_addr.sin_port = htons(13);                  /* daytime port is 13 */ 
    /* build address using inet_pton */ 
    if ( (inet_pton(AF_INET, argv[1], &dest_addr.sin_addr)) <= 0) { 
        perror("Address creation error"); 
        return -1; 
    } 
    /* send request packet */ 
    nread = sendto(sock, NULL, 0, 0, (struct sockaddr *)&dest_addr, sizeof(dest_addr)); 
    if (nread < 0) { 
        perror("Request error"); 
        return -1; 
    } 
    nread = recvfrom(sock, buffer, BUFLEN, 0, NULL, NULL); 
    if (nread < 0) { 
        perror("Read error"); 
        return -1; 
    } 
    /* print results */ 
    if (nread > 0) { 
        buffer[nread]=0; 
        if (fputs(buffer, stdout) == EOF) {          /* write daytime */ 
            perror("fputs error"); 
            return -1; 
        } 
    } 
    /* normal exit */ 
    return 0; 
} 
